/*
   (c) 2021 Christian Grieger
   GNU GENERAL PUBLIC LICENSE
*/

#ifndef TRAFFICLIGHTS_H
#define TRAFFICLIGHTS_H

#include <Arduino.h>

class TrafficLights
{
  public:
    /*
       Constructor which resets all relevant values and connects the LEDs to the pins of the Arduino.

           pinRed        Number of the red LED pin to be connected on the Arduino
           pinYellow     Number of the yellow LED pin to be connected on the Arduino
           pinGreen      Number of the green LED pin to be connected on the Arduino
           delayFactor   Optional multiplier for the delay (default=1)
           initialDelay  Optional starting delay
    */
    TrafficLights (byte pinRed, byte pinYellow, byte pinGreen, byte delayFactor = 1, byte initialDelay = 0);

    /*
       Update routine which should be called in the main loop()-function
    */
    void update ();

    static const byte RED;
    static const byte YELLOW;
    static const byte GREEN;

  protected:
    byte pins[3];
    byte delays[3];
    byte currentIndex;
    long nextAction;
};

#endif
